package simulator.stats.implementation;

import simulator.stats.GSSAccumulator;
import simulator.stats.implementation.out.StatsSerializer;

public class TaskCategoryStats implements StatsInterface {

	protected String catID;
	protected GSSAccumulator meanTaskCompletionTime;
	protected GSSAccumulator meanTaskExecutionTime;
	protected GSSAccumulator meanTaskStartTime;
	protected GSSAccumulator meanTaskFlowTime;
	protected GSSAccumulator meanTaskWaitingTime;
	protected GSSAccumulator meanTaskGQ_WaitingTime;
	protected GSSAccumulator lateness;
	protected GSSAccumulator tardiness;
	protected GSSAccumulator makespan;
	
	TaskCategoryStats(String catID) {
		this.catID = catID;
		init();
	}
	
	private void init() {
		this.meanTaskCompletionTime = new GSSAccumulator();
		this.meanTaskExecutionTime = new GSSAccumulator();
		this.meanTaskStartTime = new GSSAccumulator();
		this.meanTaskFlowTime = new GSSAccumulator();
		this.meanTaskWaitingTime = new GSSAccumulator();
		this.meanTaskGQ_WaitingTime = new GSSAccumulator();
		this.lateness = new GSSAccumulator();
		this.tardiness = new GSSAccumulator();
		this.makespan = new GSSAccumulator();
	}
	
	private String[] headers = { "catID", "meanTaskCompletionTime",
			"meanTaskExecutionTime", "meanTaskStartTime", "meanTaskFlowTime",
			"meanTaskWaitingTime", "meanTaskGQ_WaitingTime", "lateness",
			"tardiness", "makespan" };
	
	public String getCatID() {
		return catID;
	}

	public GSSAccumulator getMeanTaskCompletionTime() {
		return meanTaskCompletionTime;
	}

	public GSSAccumulator getMeanTaskExecutionTime() {
		return meanTaskExecutionTime;
	}

	public GSSAccumulator getMeanTaskStartTime() {
		return meanTaskStartTime;
	}

	public GSSAccumulator getMeanTaskFlowTime() {
		return meanTaskFlowTime;
	}

	public GSSAccumulator getMeanTaskWaitingTime() {
		return meanTaskWaitingTime;
	}

	public GSSAccumulator getMeanTaskGQ_WaitingTime() {
		return meanTaskGQ_WaitingTime;
	}

	public GSSAccumulator getLateness() {
		return lateness;
	}

	public GSSAccumulator getTardiness() {
		return tardiness;
	}

	public GSSAccumulator getMakespan() {
		return makespan;
	}

	@Override
	public Object serialize(StatsSerializer serializer) {
		return serializer.visit(this);
	}

	public String[] getHeaders() {
		return headers;
	}

}
